"use server"

import { AuthConfig } from "@/auth";
import { requestGetFetch } from "@/utils/fetch";
import { Session } from "next-auth";
import { getServerSession } from "next-auth";

export async function editClub(data: { name: string; coins: string | number }, clubId: string) {
  try {
    const session: Session = await getServerSession(AuthConfig);
    const token = session?.token;
    const path = "club/update/" + clubId;
    const response = await requestGetFetch({
      path,
      options: {
        method: "Post",
        headers: {
          // credentials: "same-origin",
          // "X-Requested-With": "XMLHttpRequest",
          Authorization: `Bearer ${token}`,
          "Content-Type": "application/json",
          Accept: "application/json",
        },
        cache: 'no-store',
        body: JSON.stringify(data || {}),
      },
    });
    return response;
  } catch (error) {
    if (error) {
      // switch (error.type) {
      //   case "CredentialsSignin":
      //     return "Invalid credentials.";
      //   default:
      //     return "Something went wrong.";
      // }
    }
    throw error;
  }
}

export async function getClubs() {
  try {
    const session: Session = await getServerSession(AuthConfig);
    const token = session?.token;
    const path = "club/list";
    const response = await requestGetFetch({
      path,
      options: {
        headers: {
          // credentials: "same-origin",
          // "X-Requested-With": "XMLHttpRequest",
          Authorization: `Bearer ${token}`,
          "Content-Type": "application/json",
          Accept: "application/json",
        },
        cache: 'no-store',
      },
    });
    var users: any[] = [];
    response?.data.map((d: any) => {
      users = [...users, ...d.playersDetails];
    });
    return users;
  } catch (error) {
    if (error) {
      // switch (error.type) {
      //   case "CredentialsSignin":
      //     return "Invalid credentials.";
      //   default:
      //     return "Something went wrong.";
      // }
    }
    throw error;
  }
}

export async function addClub(data: { name: string }) {
  try {
    const session: Session = await getServerSession(AuthConfig);
    const token = session?.token;
    const path = "club/create";
    const response = await requestGetFetch({
      path,
      options: {
        method: "Post",
        headers: {
          // credentials: "same-origin",
          // "X-Requested-With": "XMLHttpRequest",
          Authorization: `Bearer ${token}`,
          "Content-Type": "application/json",
          Accept: "application/json",
        },
        cache: 'no-store',
        body: JSON.stringify(data || {}),
      },
    });
    return response;
  } catch (error) {
    if (error) {
      // switch (error.type) {
      //   case "CredentialsSignin":
      //     return "Invalid credentials.";
      //   default:
      //     return "Something went wrong.";
      // }
    }
    throw error;
  }
}